#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * GabbleSvcChannelBundle:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _GabbleSvcChannelBundle GabbleSvcChannelBundle;

/**
 * GabbleSvcChannelBundleClass:
 *
 * The class of GabbleSvcChannelBundle.
 */
typedef struct _GabbleSvcChannelBundleClass GabbleSvcChannelBundleClass;

GType gabble_svc_channel_bundle_get_type (void);
#define GABBLE_TYPE_SVC_CHANNEL_BUNDLE \
  (gabble_svc_channel_bundle_get_type ())
#define GABBLE_SVC_CHANNEL_BUNDLE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), GABBLE_TYPE_SVC_CHANNEL_BUNDLE, GabbleSvcChannelBundle))
#define GABBLE_IS_SVC_CHANNEL_BUNDLE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GABBLE_TYPE_SVC_CHANNEL_BUNDLE))
#define GABBLE_SVC_CHANNEL_BUNDLE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), GABBLE_TYPE_SVC_CHANNEL_BUNDLE, GabbleSvcChannelBundleClass))



/**
 * GabbleSvcChannelFuture:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _GabbleSvcChannelFuture GabbleSvcChannelFuture;

/**
 * GabbleSvcChannelFutureClass:
 *
 * The class of GabbleSvcChannelFuture.
 */
typedef struct _GabbleSvcChannelFutureClass GabbleSvcChannelFutureClass;

GType gabble_svc_channel_future_get_type (void);
#define GABBLE_TYPE_SVC_CHANNEL_FUTURE \
  (gabble_svc_channel_future_get_type ())
#define GABBLE_SVC_CHANNEL_FUTURE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), GABBLE_TYPE_SVC_CHANNEL_FUTURE, GabbleSvcChannelFuture))
#define GABBLE_IS_SVC_CHANNEL_FUTURE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GABBLE_TYPE_SVC_CHANNEL_FUTURE))
#define GABBLE_SVC_CHANNEL_FUTURE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), GABBLE_TYPE_SVC_CHANNEL_FUTURE, GabbleSvcChannelFutureClass))



/**
 * GabbleSvcOLPCActivityProperties:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _GabbleSvcOLPCActivityProperties GabbleSvcOLPCActivityProperties;

/**
 * GabbleSvcOLPCActivityPropertiesClass:
 *
 * The class of GabbleSvcOLPCActivityProperties.
 */
typedef struct _GabbleSvcOLPCActivityPropertiesClass GabbleSvcOLPCActivityPropertiesClass;

GType gabble_svc_olpc_activity_properties_get_type (void);
#define GABBLE_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES \
  (gabble_svc_olpc_activity_properties_get_type ())
#define GABBLE_SVC_OLPC_ACTIVITY_PROPERTIES(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), GABBLE_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, GabbleSvcOLPCActivityProperties))
#define GABBLE_IS_SVC_OLPC_ACTIVITY_PROPERTIES(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GABBLE_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES))
#define GABBLE_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), GABBLE_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, GabbleSvcOLPCActivityPropertiesClass))


typedef void (*gabble_svc_olpc_activity_properties_set_properties_impl) (GabbleSvcOLPCActivityProperties *self,
    guint in_room,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_activity_properties_implement_set_properties (GabbleSvcOLPCActivityPropertiesClass *klass, gabble_svc_olpc_activity_properties_set_properties_impl impl);
/**
 * gabble_svc_olpc_activity_properties_return_from_set_properties:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_activity_properties_return_from_set_properties (DBusGMethodInvocation *context);
static inline void
gabble_svc_olpc_activity_properties_return_from_set_properties (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*gabble_svc_olpc_activity_properties_get_properties_impl) (GabbleSvcOLPCActivityProperties *self,
    guint in_room,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_activity_properties_implement_get_properties (GabbleSvcOLPCActivityPropertiesClass *klass, gabble_svc_olpc_activity_properties_get_properties_impl impl);
/**
 * gabble_svc_olpc_activity_properties_return_from_get_properties:
 * @context: The D-Bus method invocation context
 * @out_properties: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_activity_properties_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties);
static inline void
gabble_svc_olpc_activity_properties_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties)
{
  dbus_g_method_return (context,
      out_properties);
}

void gabble_svc_olpc_activity_properties_emit_activity_properties_changed (gpointer instance,
    guint arg_room,
    GHashTable *arg_properties);

/**
 * GabbleSvcOLPCBuddyInfo:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _GabbleSvcOLPCBuddyInfo GabbleSvcOLPCBuddyInfo;

/**
 * GabbleSvcOLPCBuddyInfoClass:
 *
 * The class of GabbleSvcOLPCBuddyInfo.
 */
typedef struct _GabbleSvcOLPCBuddyInfoClass GabbleSvcOLPCBuddyInfoClass;

GType gabble_svc_olpc_buddy_info_get_type (void);
#define GABBLE_TYPE_SVC_OLPC_BUDDY_INFO \
  (gabble_svc_olpc_buddy_info_get_type ())
#define GABBLE_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), GABBLE_TYPE_SVC_OLPC_BUDDY_INFO, GabbleSvcOLPCBuddyInfo))
#define GABBLE_IS_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GABBLE_TYPE_SVC_OLPC_BUDDY_INFO))
#define GABBLE_SVC_OLPC_BUDDY_INFO_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), GABBLE_TYPE_SVC_OLPC_BUDDY_INFO, GabbleSvcOLPCBuddyInfoClass))


typedef void (*gabble_svc_olpc_buddy_info_set_properties_impl) (GabbleSvcOLPCBuddyInfo *self,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_set_properties (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_properties_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_set_properties:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *context);
static inline void
gabble_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*gabble_svc_olpc_buddy_info_get_properties_impl) (GabbleSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_get_properties (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_properties_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_get_properties:
 * @context: The D-Bus method invocation context
 * @out_properties: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties);
static inline void
gabble_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties)
{
  dbus_g_method_return (context,
      out_properties);
}

typedef void (*gabble_svc_olpc_buddy_info_set_activities_impl) (GabbleSvcOLPCBuddyInfo *self,
    const GPtrArray *in_activities,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_set_activities (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_activities_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_set_activities:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *context);
static inline void
gabble_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*gabble_svc_olpc_buddy_info_get_activities_impl) (GabbleSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_get_activities (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_activities_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_get_activities:
 * @context: The D-Bus method invocation context
 * @out_activities: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities);
static inline void
gabble_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities)
{
  dbus_g_method_return (context,
      out_activities);
}

typedef void (*gabble_svc_olpc_buddy_info_set_current_activity_impl) (GabbleSvcOLPCBuddyInfo *self,
    const gchar *in_activity,
    guint in_channel,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_set_current_activity (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_current_activity_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_set_current_activity:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *context);
static inline void
gabble_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*gabble_svc_olpc_buddy_info_get_current_activity_impl) (GabbleSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_get_current_activity (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_current_activity_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_get_current_activity:
 * @context: The D-Bus method invocation context
 * @out_activity: const gchar * (FIXME, generate documentation)
 * @out_channel: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *context,
    const gchar *out_activity,
    guint out_channel);
static inline void
gabble_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *context,
    const gchar *out_activity,
    guint out_channel)
{
  dbus_g_method_return (context,
      out_activity,
      out_channel);
}

void gabble_svc_olpc_buddy_info_emit_properties_changed (gpointer instance,
    guint arg_contact,
    GHashTable *arg_properties);
void gabble_svc_olpc_buddy_info_emit_activities_changed (gpointer instance,
    guint arg_contact,
    const GPtrArray *arg_activities);
void gabble_svc_olpc_buddy_info_emit_current_activity_changed (gpointer instance,
    guint arg_contact,
    const gchar *arg_activity,
    guint arg_channel);

/**
 * GabbleSvcOLPCGadget:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _GabbleSvcOLPCGadget GabbleSvcOLPCGadget;

/**
 * GabbleSvcOLPCGadgetClass:
 *
 * The class of GabbleSvcOLPCGadget.
 */
typedef struct _GabbleSvcOLPCGadgetClass GabbleSvcOLPCGadgetClass;

GType gabble_svc_olpc_gadget_get_type (void);
#define GABBLE_TYPE_SVC_OLPC_GADGET \
  (gabble_svc_olpc_gadget_get_type ())
#define GABBLE_SVC_OLPC_GADGET(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), GABBLE_TYPE_SVC_OLPC_GADGET, GabbleSvcOLPCGadget))
#define GABBLE_IS_SVC_OLPC_GADGET(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GABBLE_TYPE_SVC_OLPC_GADGET))
#define GABBLE_SVC_OLPC_GADGET_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), GABBLE_TYPE_SVC_OLPC_GADGET, GabbleSvcOLPCGadgetClass))


typedef void (*gabble_svc_olpc_gadget_search_buddies_by_properties_impl) (GabbleSvcOLPCGadget *self,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_gadget_implement_search_buddies_by_properties (GabbleSvcOLPCGadgetClass *klass, gabble_svc_olpc_gadget_search_buddies_by_properties_impl impl);
/**
 * gabble_svc_olpc_gadget_return_from_search_buddies_by_properties:
 * @context: The D-Bus method invocation context
 * @out_view: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_gadget_return_from_search_buddies_by_properties (DBusGMethodInvocation *context,
    const gchar *out_view);
static inline void
gabble_svc_olpc_gadget_return_from_search_buddies_by_properties (DBusGMethodInvocation *context,
    const gchar *out_view)
{
  dbus_g_method_return (context,
      out_view);
}

typedef void (*gabble_svc_olpc_gadget_search_buddies_by_alias_impl) (GabbleSvcOLPCGadget *self,
    const gchar *in_alias,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_gadget_implement_search_buddies_by_alias (GabbleSvcOLPCGadgetClass *klass, gabble_svc_olpc_gadget_search_buddies_by_alias_impl impl);
/**
 * gabble_svc_olpc_gadget_return_from_search_buddies_by_alias:
 * @context: The D-Bus method invocation context
 * @out_view: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_gadget_return_from_search_buddies_by_alias (DBusGMethodInvocation *context,
    const gchar *out_view);
static inline void
gabble_svc_olpc_gadget_return_from_search_buddies_by_alias (DBusGMethodInvocation *context,
    const gchar *out_view)
{
  dbus_g_method_return (context,
      out_view);
}

typedef void (*gabble_svc_olpc_gadget_request_random_buddies_impl) (GabbleSvcOLPCGadget *self,
    guint in_max,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_gadget_implement_request_random_buddies (GabbleSvcOLPCGadgetClass *klass, gabble_svc_olpc_gadget_request_random_buddies_impl impl);
/**
 * gabble_svc_olpc_gadget_return_from_request_random_buddies:
 * @context: The D-Bus method invocation context
 * @out_view: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_gadget_return_from_request_random_buddies (DBusGMethodInvocation *context,
    const gchar *out_view);
static inline void
gabble_svc_olpc_gadget_return_from_request_random_buddies (DBusGMethodInvocation *context,
    const gchar *out_view)
{
  dbus_g_method_return (context,
      out_view);
}

typedef void (*gabble_svc_olpc_gadget_search_activities_by_properties_impl) (GabbleSvcOLPCGadget *self,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_gadget_implement_search_activities_by_properties (GabbleSvcOLPCGadgetClass *klass, gabble_svc_olpc_gadget_search_activities_by_properties_impl impl);
/**
 * gabble_svc_olpc_gadget_return_from_search_activities_by_properties:
 * @context: The D-Bus method invocation context
 * @out_view: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_gadget_return_from_search_activities_by_properties (DBusGMethodInvocation *context,
    const gchar *out_view);
static inline void
gabble_svc_olpc_gadget_return_from_search_activities_by_properties (DBusGMethodInvocation *context,
    const gchar *out_view)
{
  dbus_g_method_return (context,
      out_view);
}

typedef void (*gabble_svc_olpc_gadget_request_random_activities_impl) (GabbleSvcOLPCGadget *self,
    guint in_max,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_gadget_implement_request_random_activities (GabbleSvcOLPCGadgetClass *klass, gabble_svc_olpc_gadget_request_random_activities_impl impl);
/**
 * gabble_svc_olpc_gadget_return_from_request_random_activities:
 * @context: The D-Bus method invocation context
 * @out_view: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_gadget_return_from_request_random_activities (DBusGMethodInvocation *context,
    const gchar *out_view);
static inline void
gabble_svc_olpc_gadget_return_from_request_random_activities (DBusGMethodInvocation *context,
    const gchar *out_view)
{
  dbus_g_method_return (context,
      out_view);
}

typedef void (*gabble_svc_olpc_gadget_search_activities_by_participants_impl) (GabbleSvcOLPCGadget *self,
    const GArray *in_participants,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_gadget_implement_search_activities_by_participants (GabbleSvcOLPCGadgetClass *klass, gabble_svc_olpc_gadget_search_activities_by_participants_impl impl);
/**
 * gabble_svc_olpc_gadget_return_from_search_activities_by_participants:
 * @context: The D-Bus method invocation context
 * @out_view: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_gadget_return_from_search_activities_by_participants (DBusGMethodInvocation *context,
    const gchar *out_view);
static inline void
gabble_svc_olpc_gadget_return_from_search_activities_by_participants (DBusGMethodInvocation *context,
    const gchar *out_view)
{
  dbus_g_method_return (context,
      out_view);
}

typedef void (*gabble_svc_olpc_gadget_publish_impl) (GabbleSvcOLPCGadget *self,
    gboolean in_publish,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_gadget_implement_publish (GabbleSvcOLPCGadgetClass *klass, gabble_svc_olpc_gadget_publish_impl impl);
/**
 * gabble_svc_olpc_gadget_return_from_publish:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_gadget_return_from_publish (DBusGMethodInvocation *context);
static inline void
gabble_svc_olpc_gadget_return_from_publish (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void gabble_svc_olpc_gadget_emit_gadget_discovered (gpointer instance);

/**
 * GabbleSvcOLPCView:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _GabbleSvcOLPCView GabbleSvcOLPCView;

/**
 * GabbleSvcOLPCViewClass:
 *
 * The class of GabbleSvcOLPCView.
 */
typedef struct _GabbleSvcOLPCViewClass GabbleSvcOLPCViewClass;

GType gabble_svc_olpc_view_get_type (void);
#define GABBLE_TYPE_SVC_OLPC_VIEW \
  (gabble_svc_olpc_view_get_type ())
#define GABBLE_SVC_OLPC_VIEW(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), GABBLE_TYPE_SVC_OLPC_VIEW, GabbleSvcOLPCView))
#define GABBLE_IS_SVC_OLPC_VIEW(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GABBLE_TYPE_SVC_OLPC_VIEW))
#define GABBLE_SVC_OLPC_VIEW_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), GABBLE_TYPE_SVC_OLPC_VIEW, GabbleSvcOLPCViewClass))


typedef void (*gabble_svc_olpc_view_get_activities_impl) (GabbleSvcOLPCView *self,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_view_implement_get_activities (GabbleSvcOLPCViewClass *klass, gabble_svc_olpc_view_get_activities_impl impl);
/**
 * gabble_svc_olpc_view_return_from_get_activities:
 * @context: The D-Bus method invocation context
 * @out_activities: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_view_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities);
static inline void
gabble_svc_olpc_view_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities)
{
  dbus_g_method_return (context,
      out_activities);
}

typedef void (*gabble_svc_olpc_view_get_buddies_impl) (GabbleSvcOLPCView *self,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_view_implement_get_buddies (GabbleSvcOLPCViewClass *klass, gabble_svc_olpc_view_get_buddies_impl impl);
/**
 * gabble_svc_olpc_view_return_from_get_buddies:
 * @context: The D-Bus method invocation context
 * @out_buddies: const GArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_view_return_from_get_buddies (DBusGMethodInvocation *context,
    const GArray *out_buddies);
static inline void
gabble_svc_olpc_view_return_from_get_buddies (DBusGMethodInvocation *context,
    const GArray *out_buddies)
{
  dbus_g_method_return (context,
      out_buddies);
}

typedef void (*gabble_svc_olpc_view_close_impl) (GabbleSvcOLPCView *self,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_view_implement_close (GabbleSvcOLPCViewClass *klass, gabble_svc_olpc_view_close_impl impl);
/**
 * gabble_svc_olpc_view_return_from_close:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_view_return_from_close (DBusGMethodInvocation *context);
static inline void
gabble_svc_olpc_view_return_from_close (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void gabble_svc_olpc_view_emit_activities_changed (gpointer instance,
    const GPtrArray *arg_added,
    const GPtrArray *arg_removed);
void gabble_svc_olpc_view_emit_buddies_changed (gpointer instance,
    const GArray *arg_added,
    const GArray *arg_removed);
void gabble_svc_olpc_view_emit_closed (gpointer instance);


G_END_DECLS
